# yapf_rail.cpp File Reference

The rail pathfinding. More...

`#include "../../stdafx.h"`
`#include "yapf.hpp"`
`#include "yapf_cache.h"`
`#include "yapf_node_rail.hpp"`
`#include "yapf_costrail.hpp"`
`#include "yapf_destrail.hpp"`
`#include "../../functions.h"`

Go to the source code of this file.

## Data Structures
class | CYapfReserveTrack< Types >
class | CYapfFollowAnyDepotRailT< Types >
class | CYapfFollowAnySafeTileRailT< Types >
class | CYapfFollowRailT< Types >
struct | CYapfRail_TypesT< Tpf_, Ttrack_follower, Tnode_list, TdestinationT, TfollowT >
struct | CYapfRail1
struct | CYapfRail2
struct | CYapfAnyDepotRail1
struct | CYapfAnyDepotRail2
struct | CYapfAnySafeTileRail1
struct | CYapfAnySafeTileRail2
## Defines
#define | DEBUG_YAPF_CACHE 0
## Functions
Track | YapfTrainChooseTrack (const Train *v, TileIndex tile, DiagDirection enterdir, TrackBits tracks, bool *path_not_found, bool reserve_track, PBSTileInfo *target)
| Finds the best path for given train using YAPF.
bool | YapfTrainCheckReverse (const Train *v)
| Returns true if it is better to reverse the train before leaving station using YAPF.
FindDepotData | YapfTrainFindNearestDepot (const Train *v, int max_penalty)
| Used when user sends train to the nearest depot or if train needs servicing using YAPF.
bool | YapfTrainFindNearestSafeTile (const Train *v, TileIndex tile, Trackdir td, bool override_railtype)
| Try to extend the reserved path of a train to the nearest safe tile using YAPF.
void | YapfNotifyTrackLayoutChange (TileIndex tile, Track track)
| Use this function to notify YAPF that track layout (or signal configuration) has change.
## Variables
int | _total_pf_time_us = 0

## Detailed Description

The rail pathfinding.

Definition in file yapf_rail.cpp.

## Function Documentation

void YapfNotifyTrackLayoutChange | ( | TileIndex | tile,
|  | Track | track |
| ) |  |  |

Use this function to notify YAPF that track layout (or signal configuration) has change.

Parameters:

  | tile | the tile that is changed
  | track | what piece of track is changed

Definition at line 642 of file yapf_rail.cpp.

Referenced by CmdBuildBridge(), CmdBuildRailStation(), CmdBuildRailWaypoint(), CmdBuildRoad(), CmdBuildSingleRail(), CmdBuildSingleSignal(), CmdBuildTrainDepot(), CmdBuildTunnel(), CmdConvertRail(), CmdRemoveSingleRail(), CmdRemoveSingleSignal(), RemoveFromRailBaseStation(), RemoveRailStation(), RemoveRoad(), and CYapfReserveTrack< Types >::TryReservePath().

bool YapfTrainCheckReverse | ( | const Train * | v | ) |

Returns true if it is better to reverse the train before leaving station using YAPF.

Parameters:

  | v | the train leaving the station

Returns:
  true if reversing is better

Definition at line 544 of file yapf_rail.cpp.

References _settings_game, DistanceManhattan(), PathfinderSettings::forbid_90_deg, GetOtherTunnelBridgeEnd(), GetTunnelBridgeDirection(), Train::GetVehicleTrackdir(), SpecializedVehicle< T, Type >::Last(), GameSettings::pf, ReverseTrackdir(), Vehicle::tile, TRACK_BIT_WORMHOLE, TrackdirToExitdir(), and YAPF_TILE_LENGTH.

Track YapfTrainChooseTrack | ( | const Train * | v,
|  | TileIndex | tile,
|  | DiagDirection | enterdir,
|  | TrackBits | tracks,
|  | bool * | path_not_found,
|  | bool | reserve_track,
|  | struct PBSTileInfo * | target |
| ) |  |  |

Finds the best path for given train using YAPF.

Parameters:

  | v | the train that needs to find a path
  | tile | the tile to find the path from (should be next tile the train is about to enter)
  | enterdir | diagonal direction which the RV will enter this new tile from
  | tracks | available trackdirs on the new tile (to choose from)
  | path_not_found | [out] true is returned if no path can be found (returned Trackdir is only a 'guess')
  | reserve_track | indicates whether YAPF should try to reserve the found path
  | target | [out] the target tile of the reservation, free is set to true if path was reserved

Returns:
  the best track for next turn

Definition at line 529 of file yapf_rail.cpp.

References _settings_game, FindFirstTrack(), PathfinderSettings::forbid_90_deg, INVALID_TRACKDIR, GameSettings::pf, and TrackdirToTrack().

Referenced by DoTrainPathfind().

FindDepotData YapfTrainFindNearestDepot | ( | const Train * | v,
|  | int | max_distance |
| ) |  |  |

Used when user sends train to the nearest depot or if train needs servicing using YAPF.

Parameters:

  | v | train that needs to go to some depot
  | max_penalty | max distance (int pathfinder penalty) from the current train position (used also as optimization - the pathfinder can stop path finding if max_penalty was reached and no depot was seen)

Returns:
  the data about the depot

Definition at line 603 of file yapf_rail.cpp.

References _settings_game, FindDepotData::best_length, FollowTrainReservation(), PathfinderSettings::forbid_90_deg, Train::GetVehicleTrackdir(), SpecializedVehicle< T, Type >::Last(), GameSettings::pf, FindDepotData::reverse, ReverseTrackdir(), FindDepotData::tile, PBSTileInfo::tile, Vehicle::tile, PBSTileInfo::trackdir, and YAPF_INFINITE_PENALTY.

Referenced by FindClosestTrainDepot().

bool YapfTrainFindNearestSafeTile | ( | const Train * | v,
|  | TileIndex | tile,
|  | Trackdir | td,
|  | bool | override_railtype |
| ) |  |  |

Try to extend the reserved path of a train to the nearest safe tile using YAPF.

Parameters:

  | v | The train that needs to find a safe tile.
  | tile | Last tile of the current reserved path.
  | td | Last trackdir of the current reserved path.
  | override_railtype | Should all physically compatible railtypes be searched, even if the vehicle can't run on them on its own?

Returns:
  True if the path could be extended to a safe tile.

Definition at line 626 of file yapf_rail.cpp.

References _settings_game, PathfinderSettings::forbid_90_deg, and GameSettings::pf.

Referenced by TryReserveSafeTrack().